/*!
 * MediaElement.js
 * http://www.mediaelementjs.com/
 *
 * Wrapper that mimics native HTML5 MediaElement (audio and video)
 * using a variety of technologies (pure JavaScript, Flash, iframe)
 *
 * Copyright 2010-2017, John Dyer (http://j.hn/)
 * License: MIT
 *
 */
!function r(a,i,l){function f(s,e){if(!i[s]){if(!a[s]){var t="function"==typeof require&&require;if(!e&&t)return t(s,!0);if(p)return p(s,!0);var o=new Error("Cannot find module '"+s+"'");throw o.code="MODULE_NOT_FOUND",o}var n=i[s]={exports:{}};a[s][0].call(n.exports,function(e){var t=a[s][1][e];return f(t||e)},n,n.exports,r,a,i,l)}return i[s].exports}for(var p="function"==typeof require&&require,e=0;e<l.length;e++)f(l[e]);return f}({1:[function(e,t,s){"use strict";mejs.i18n.en["mejs.frame-rate"]="Media frame rate (select according to your video source)",mejs.i18n.en["mejs.step-fwd"]="Step forward",mejs.i18n.en["mejs.step-back"]="Step back",Object.assign(mejs.MepDefaults,{frameRates:[30,60],fps:null,defaultFps:30,fpsLabel:"FPS"}),Object.assign(MediaElementPlayer.prototype,{buildframeNavigator:function(i,e,t,r){var l=this;if(i&&i.isVideo){var o=[],s=mejs.i18n.t("mejs.frame-rate"),f=function(e){for(var t=0,s=o.length;t<s;t++)if(o[t].value===e)return o[t].name},n=function(e){var t=1/l.options.fps,s=isNaN(r.duration)?t:r.duration;if(s){var o=r.currentTime===1/0?0:r.currentTime,n="back"===e?o-t:o+t;r.paused||r.pause(),r.setCurrentTime(Math.min(n,s))}},a=mejs.i18n.t("mejs.step-fwd"),p=document.createElement("div"),u=mejs.i18n.t("mejs.step-back"),c=document.createElement("div");c.className=l.options.classPrefix+"button "+l.options.classPrefix+"skip-back-button",c.innerHTML='<button type="button" aria-controls="'+l.id+'" title="'+u+'" aria-label="'+u+'" tabindex="0"></button>',c.addEventListener("click",function(){n("back")}),p.className=l.options.classPrefix+"button "+l.options.classPrefix+"jump-forward-button",p.innerHTML='<button type="button" aria-controls="'+l.id+'" title="'+a+'" aria-label="'+a+'" tabindex="0"></button>',p.addEventListener("click",function(){n("fwd")});for(var d=!1,m=0,v=l.options.frameRates.length;m<v;m++){var b=l.options.frameRates[m];"number"==typeof b?(o.push({name:""+b+l.options.fpsLabel,value:b}),b===l.options.defaultFps&&(d=!0)):(o.push(b),b.value===l.options.defaultFps&&(d=!0))}d||o.push({name:l.options.defaultFps+l.options.fpsLabel,value:l.options.defaultFps}),l.options.fps=l.options.defaultFps,o.sort(function(e,t){return t.value-e.value}),l.cleanframeNavigator(i),i.fpsButton=document.createElement("div"),i.fpsButton.className=l.options.classPrefix+"button "+l.options.classPrefix+"fps-button",i.fpsButton.innerHTML='<button type="button" aria-controls="'+l.id+'" title="'+s+'" aria-label="'+s+'" tabindex="0">'+f(l.options.defaultFps)+'</button><div class="'+l.options.classPrefix+"fps-selector "+l.options.classPrefix+'offscreen"><ul class="'+l.options.classPrefix+'fps-selector-list"></ul></div>',l.addControlElement(i.fpsButton,"frameNavigator"),l.addControlElement(p,"frameNavigator"),l.addControlElement(c,"frameNavigator");for(var h=0,x=o.length;h<x;h++){var g=l.id+"-fps-"+o[h].value;i.fpsButton.querySelector("ul").innerHTML+='<li class="'+l.options.classPrefix+'fps-selector-list-item"><span><input class="'+l.options.classPrefix+'fps-selector-input" type="radio" name="'+l.id+'_frameNavigator"disabled="disabled" value="'+o[h].value+'" id="'+g+'"  '+(o[h].value===l.options.defaultFps?' checked="checked"':"")+'/></span><label for="'+g+'" class="'+l.options.classPrefix+"fps-selector-label"+(o[h].value===l.options.defaultFps?" "+l.options.classPrefix+"fps-selected":"")+'">'+o[h].name+"</label></li>"}l.options.defaultFps,i.fpsSelector=i.fpsButton.querySelector("."+l.options.classPrefix+"fps-selector");for(var j=["mouseenter","focusin"],P=["mouseleave","focusout"],y=i.fpsButton.querySelectorAll('input[type="radio"]'),S=i.fpsButton.querySelectorAll("."+l.options.classPrefix+"fps-selector-label"),B=0,k=j.length;B<k;B++)i.fpsButton.addEventListener(j[B],function(){mejs.Utils.removeClass(i.fpsSelector,l.options.classPrefix+"offscreen"),i.fpsSelector.style.height=i.fpsSelector.querySelector("ul").offsetHeight,i.fpsSelector.style.top=-1*parseFloat(i.fpsSelector.offsetHeight)+"px"});for(var N=0,E=P.length;N<E;N++)i.fpsSelector.addEventListener(P[N],function(){mejs.Utils.addClass(this,l.options.classPrefix+"offscreen")});for(var L=0,F=y.length;L<F;L++){var C=y[L];C.disabled=!1,C.addEventListener("click",function(){var e=parseFloat(this.value);e,l.options.fps=parseFloat(e),i.fpsButton.querySelector("button").innerHTML=f(e);for(var t=i.fpsButton.querySelectorAll("."+l.options.classPrefix+"fps-selected"),s=0,o=t.length;s<o;s++)mejs.Utils.removeClass(t[s],l.options.classPrefix+"fps-selected");this.checked=!0;for(var n=mejs.Utils.siblings($(this).parent()[0],function(e){return mejs.Utils.hasClass(e,l.options.classPrefix+"fps-selector-label")}),r=0,a=n.length;r<a;r++)mejs.Utils.addClass(n[r],l.options.classPrefix+"fps-selected")})}for(var q=0,w=S.length;q<w;q++)S[q].addEventListener("click",function(){var e=mejs.Utils.siblings(this,function(e){return e.querySelector("input")})[0];mejs.Utils.createEvent("click",e)});i.fpsSelector.addEventListener("keydown",function(e){e.stopPropagation()})}},cleanframeNavigator:function(e){e&&(e.fpsButton&&e.fpsButton.parentNode.removeChild(e.fpsButton),e.fpsSelector&&e.fpsSelector.parentNode.removeChild(e.fpsSelector),e.fwdButton&&e.fwdButton.parentNode.removeChild(e.fwdButton),e.backButton&&e.backButton.parentNode.removeChild(e.backButton))}})},{}]},{},[1]);